      subroutine cacheuv(x)
      real*8 x,y
      REAL*8 U,V,DLU,DLV,UU,VV
      common/uv/U,V,DLU,DLV,UU(40),VV(40)
!$OMP THREADPRIVATE(/uv/)
      integer K

      if(0D0<x.and.x<(sqrt(2D0)-1D0))then
         y = x
      elseif(sqrt(2D0)-1D0<x.and.x<1D0)then
         y = (1D0 - x)/(1D0 + x)
      endif
      
      U  =  DLOG(1.0D0+y)
      V  = -DLOG(1.0D0-y)
      DLU=  DLOG(U)
      DLV=  DLOG(V)

      do K=1,40
         UU(K) = U**K
         VV(K) = V**K
      end do

!c alternative without powers      
!      UU(1) = U
!      VV(1) = V
!      do K=2,40
!         UU(K) = UU(K-1)*U
!         VV(K) = VV(K-1)*V
!      end do

      end
*--------------------------------------------------------------
      REAL*8 FUNCTION HB1(I1,X)
*--------------------------------------------------------------    
*
*     Weight w = 1 HPLs     
*
*--------------------------------------------------------------    
*
      IMPLICIT NONE
*
      INTEGER I1
      REAL*8 X,T
*  
      IF(I1.EQ.-1) GOTO 1
      IF(I1.EQ. 0) GOTO 2
      IF(I1.EQ. 1) GOTO 3
*
      WRITE(6,*) 'I1=',I1,' *** W=1, NOT IN RANGE, STOP: HB1 ***'
      STOP
*
1     T = DLOG(1.0D0+X)
      GOTO 10
2     T = DLOG(X)
      GOTO 10
3     T = -DLOG(1.0D0-X)
*
10    HB1 = T
*
      RETURN
      END
*--------------------------------------------------------------    
      REAL*8 FUNCTION HB2(I1,I2,X)
*--------------------------------------------------------------    
*
*     Weight w = 2 HPLs     
*
*--------------------------------------------------------------    
*
      IMPLICIT NONE
*
      INTEGER I1,I2,J,K,JJ
      REAL*8 X,T1,T2,T3,U,V
      REAL*8 DA2
*
      COMMON /JJ/ JJ
      COMMON /DLIST2/  DA2(360)
*
      CALL HPOLYC(X)
*
      CALL CHECKB2(I1,I2,J)
*     J = JJ

      U= DLOG(1.0D0+X)
      V=-DLOG(1.0D0-X)
*
      T1=0.0D0
      DO 1 K=1,40
      T1=T1+U**K*DA2((J-1)*40+K)
1     CONTINUE
      T2=0.0D0
      DO 2 K=1,40
      T2=T2+U**K*DA2(120+(J-1)*40+K)
2     CONTINUE
      T2=T2*DLOG(U)
      T3=0.0D0
      DO 3 K=1,40
      T3=T3+V**K*DA2(240+(J-1)*40+K)
3     CONTINUE
*
      HB2=T1+T2+T3
*
      RETURN
      END
*--------------------------------------------------------------    
      REAL*8 FUNCTION HB3(I1,I2,I3,X)
*--------------------------------------------------------------    
*
*     Weight w = 3 HPLs     
*
*--------------------------------------------------------------    
*
      IMPLICIT NONE
*
      INTEGER I1,I2,I3,J,K,JJ
      REAL*8 X,T1,T2,T3,T4,T5
      REAL*8 DA3
      REAL*8 UK,VK
      REAL*8 U,V,DLU,DLV,UU,VV
      common/uv/U,V,DLU,DLV,UU(40),VV(40)
!$OMP THREADPRIVATE(/uv/)
*
      COMMON /DLIST3/  DA3(1600)
      COMMON /JJ/ JJ
*
*
      CALL CHECKB3(I1,I2,I3,J)
*
*
      T1=0.0D0
      T2=0.0D0
      T3=0.0D0
      T4=0.0D0
      T5=0.0D0
      do K=1,40
         T1=T1+UU(K)*DA3((J-1)*40+K)
         T2=T2+UU(K)*DA3(320+(J-1)*40+K)
         T3=T3+UU(K)*DA3(640+(J-1)*40+K)
         T4=T4+VV(K)*DA3(960+(J-1)*40+K)
         T5=T5+VV(K)*DA3(1280+(J-1)*40+K)
      enddo
      T2=T2*DLU
      T3=T3*DLU*DLU
      T5=T5*DLV
!*
      HB3=T1+T2+T3+T4+T5

      RETURN
      END
*--------------------------------------------------------------    
      REAL*8 FUNCTION HB4(I1,I2,I3,I4,X)
*--------------------------------------------------------------    
*
*     Weight w = 4 HPLs     
*
*--------------------------------------------------------------    
*
      IMPLICIT NONE
*
      INTEGER I1,I2,I3,I4,J,K,JJ
      REAL*8 X,T1,T2,T3,T4,T5,T6,T7
      REAL*8 DA4
      REAL*8 UK,VK
      REAL*8 U,V,DLU,DLV,UU,VV
      common/uv/U,V,DLU,DLV,UU(40),VV(40)
!$OMP THREADPRIVATE(/uv/)
*     
      COMMON /JJ/ JJ
      COMMON /DLIST4/  DA4(5040)
*
      CALL CHECKB4(I1,I2,I3,I4,J)
*
*
      T1=0.0D0
      T2=0.0D0
      T3=0.0D0
      T4=0.0D0
      T5=0.0D0
      T6=0.0D0
      T7=0.0D0
      DO 1 K=1,40
         T1=T1+UU(K)*DA4((J-1)*40+K)
         T2=T2+UU(K)*DA4(720+(J-1)*40+K)
         T3=T3+UU(K)*DA4(1440+(J-1)*40+K)
         T4=T4+UU(K)*DA4(2160+(J-1)*40+K)
         T5=T5+VV(K)*DA4(2880+(J-1)*40+K)
         T6=T6+VV(K)*DA4(3600+(J-1)*40+K)
         T7=T7+VV(K)*DA4(4320+(J-1)*40+K)
 1    CONTINUE
      T2=T2*DLU
      T3=T3*DLU*DLU
      T4=T4*DLU*DLU*DLU
      T6=T6*DLV
      T7=T7*DLV*DLV
*
      HB4=T1+T2+T3+T4+T5+T6+T7
*
      RETURN
      END
*--------------------------------------------------------------    
      REAL*8 FUNCTION HB5(I1,I2,I3,I4,I5,X)
*--------------------------------------------------------------    
*
*     Weight w = 5 HPLs     
*
*--------------------------------------------------------------    
*
      IMPLICIT NONE
*
      INTEGER I1,I2,I3,I4,I5,J,K,JJ
      REAL*8 X,T1,T2,T3,T4,T5,T6,T7,T8,T9,U,V,DLU,DLV
      REAL*8 DA5
*
      COMMON /DLIST5/  DA5(17280)
      COMMON /JJ/ JJ
*
      CALL HPOLYC(X)
*
      CALL CHECKB5(I1,I2,I3,I4,I5,J)
*     J = JJ
*
      U  =  DLOG(1.0D0+X)
      V  = -DLOG(1.0D0-X)
      DLU=  DLOG(U)
      DLV=  DLOG(V)
*
      T1=0.0D0
      DO 1 K=1,40
      T1=T1+U**K*DA5((J-1)*40+K)
1     CONTINUE
      T2=0.0D0
      DO 2 K=1,40
      T2=T2+U**K*DA5(1920+(J-1)*40+K)
2     CONTINUE
      T2=T2*DLU
      T3=0.0D0
      DO 3 K=1,40
      T3=T3+U**K*DA5(3840+(J-1)*40+K)
3     CONTINUE
      T3=T3*DLU*DLU
      T4=0.0D0
      DO 4 K=1,40
      T4=T4+U**K*DA5(5760+(J-1)*40+K)
4     CONTINUE
      T4=T4*DLU*DLU*DLU
      T5=0.0D0
      DO 5 K=1,40
      T5=T5+U**K*DA5(7680+(J-1)*40+K)
5     CONTINUE
      T5=T5*DLU*DLU*DLU*DLU
      T6=0.0D0
      DO 6 K=1,40
      T6=T6+V**K*DA5(9600+(J-1)*40+K)
6     CONTINUE
      T7=0.0D0
      DO 7 K=1,40
      T7=T7+V**K*DA5(11520+(J-1)*40+K)
7     CONTINUE
      T7=T7*DLV
      T8=0.0D0
      DO 8 K=1,40
      T8=T8+V**K*DA5(13440+(J-1)*40+K)
8     CONTINUE
      T8=T8*DLV*DLV
      T9=0.0D0
      DO 9 K=1,40
      T9=T9+V**K*DA5(15360+(J-1)*40+K)
9     CONTINUE
      T9=T9*DLV*DLV*DLV
*
      HB5=T1+T2+T3+T4+T5+T6+T7+T8+T9
*
      RETURN
      END
