#ifndef muf_h
#define muf_h

#include <complex>

using namespace std;

namespace muf
{
//  extern complex <double> *qqb;
//  extern complex <double> *qg;
//  extern complex <double> *qq;
//  extern complex <double> *qqp;
//  extern complex <double> *gg;
//  extern complex <double> *qqbp;
//  extern complex <double> *qbg;
//  extern complex <double> *qpg;
//  extern complex <double> *qbpg;
//#pragma omp threadprivate(qqb,qg,qq,qqp,qqbp,gg,qbg,qpg,qbpg)

  extern double LR  ;
  extern double LR2 ;
  extern double LR3 ;
  extern double LF  ;
  extern double LF2 ;
  extern double LF3 ;
  extern double LF4 ;
  extern double LQ  ;
  extern double LQ2 ;
  extern double LQ3 ;
  extern double LQ4 ;
  extern double LQ5 ;
  extern double LQ6 ;
  extern double LQ7 ;
  extern double LQF ;
  extern double LQF2;
  extern double LQF3;
  extern double LQF4;
  extern double A1  ;
  extern double A2  ;
  extern double A3  ;
  extern double A4  ;
  extern double B1  ;
  extern double B2  ;
  extern double B3  ;
  extern double B4  ;
#pragma omp threadprivate(LR,LR2,LR3,LF,LF2,LF3,LF4,LQ,LQ2,LQ3,LQ4,LQ5,LQ6,LQ7,LQF,LQF2,LQF3,LQF4,A1,A2,A3,A4,B1,B2,B3,B4)

  extern complex <double> *EC1qq   ;
  extern complex <double> *EC2qq   ;
  extern complex <double> *EC3qq   ;
  extern complex <double> *EC1qg   ;
  extern complex <double> *EC2qg   ;
  extern complex <double> *EC3qg   ;
  extern complex <double> *EC2qqp  ;
  extern complex <double> *EC2qqb  ;
  extern complex <double> *EC2qqbp ;
  extern complex <double> *EC3qqp  ;
  extern complex <double> *EC3qqb  ;
  extern complex <double> *EC3qqbp ;
#pragma omp threadprivate(EC1qq,EC2qq,EC3qq,EC1qg,EC2qg,EC3qg,EC2qqp,EC2qqb,EC2qqbp,EC3qqp,EC3qqb,EC3qqbp)
  
  extern complex <double> *qqb;
  extern complex <double> *qg;
  extern complex <double> *qg_1;
  extern complex <double> *qg_2;
  extern complex <double> *qq;
  extern complex <double> *qq_1;
  extern complex <double> *qq_2;
  extern complex <double> *qqp;
  extern complex <double> *qqp_1;
  extern complex <double> *qqp_2;
  extern complex <double> *qqbp;
  extern complex <double> *qqbp_1;
  extern complex <double> *qqbp_2;
  extern complex <double> *gg;
  extern complex <double> *qbg;
  extern complex <double> *qbg_1;
  extern complex <double> *qbg_2;
  extern complex <double> *qpg;
  extern complex <double> *qpg_1;
  extern complex <double> *qpg_2;
  extern complex <double> *qbpg;
  extern complex <double> *qbpg_1;
  extern complex <double> *qbpg_2;
  extern complex <double> *qbq;
  extern complex <double> *qpqbp;
  extern complex <double> *qbpqp;
  extern complex <double> *qbqp;
  extern complex <double> *qbqp_1;
  extern complex <double> *qbqp_2;
  extern complex <double> *qbqbp;
  extern complex <double> *qbqbp_1;
  extern complex <double> *qbqbp_2;
  extern complex <double> *qpqp;
  extern complex <double> *qpqp_1;
  extern complex <double> *qpqp_2;
#pragma omp threadprivate(qqb,qg,qg_1,qg_2,qq,qq_1,qq_2,qqp,qqp_1,qqp_2,qqbp,qqbp_1,qqbp_2,gg,qbg,qbg_1,qbg_2,qpg,qpg_1,qpg_2,qbpg,qbpg_1,qbpg_2,qbq,qpqbp,qbpqp,qbqp,qbqp_1,qbqp_2,qbqbp,qbqbp_1,qbqbp_2,qpqp,qpqp_1,qpqp_2)
  
  //Split b-dependent C exponentiation
  extern complex <double> *qqb_eqqb;
  extern complex <double> *qg_eqqb;
  extern complex <double> *qq_eqqb;
  extern complex <double> *qqp_eqqb;
  extern complex <double> *qqbp_eqqb;
  extern complex <double> *gg_eqqb;
  extern complex <double> *qbg_eqqb;
  extern complex <double> *qpg_eqqb;
  extern complex <double> *qbpg_eqqb;
  extern complex <double> *qbq_eqqb;
  extern complex <double> *qpqbp_eqqb;
  extern complex <double> *qbpqp_eqqb;
  extern complex <double> *qbqp_eqqb;
  extern complex <double> *qbqbp_eqqb;
  extern complex <double> *qpqp_eqqb;
  extern complex <double> *qqb_eqg;
  extern complex <double> *qg_eqg;
  extern complex <double> *qq_eqg;
  extern complex <double> *qqp_eqg;
  extern complex <double> *qqbp_eqg;
  extern complex <double> *gg_eqg;
  extern complex <double> *qbg_eqg;
  extern complex <double> *qpg_eqg;
  extern complex <double> *qbpg_eqg;
  extern complex <double> *qbq_eqg;
  extern complex <double> *qbqp_eqg;
  extern complex <double> *qbqbp_eqg;
  extern complex <double> *qpqp_eqg;
  extern complex <double> *qpqbp_eqg;
  extern complex <double> *qbpqp_eqg;
  extern complex <double> *qg_eqq;
  extern complex <double> *qq_eqq;
  extern complex <double> *qbg_eqq;
  extern complex <double> *gg_eqq;
  extern complex <double> *qbq_eqq;
  extern complex <double> *qbqp_eqq;
  extern complex <double> *qbqbp_eqq;
  extern complex <double> *qg_eqqp;
  extern complex <double> *qqp_eqqp;
  extern complex <double> *qbpg_eqqp;
  extern complex <double> *gg_eqqp;
  extern complex <double> *qbqp_eqqp;
  extern complex <double> *qpqp_eqqp;
  extern complex <double> *qbpqp_eqqp;
  extern complex <double> *qg_eqqbp;
  extern complex <double> *qqbp_eqqbp;
  extern complex <double> *qpg_eqqbp;
  extern complex <double> *gg_eqqbp;
  extern complex <double> *qbqbp_eqqbp;
  extern complex <double> *qpqp_eqqbp;
  extern complex <double> *qpqbp_eqqbp;
  extern complex <double> *qg_egg;
  extern complex <double> *gg_egg;
  extern complex <double> *qbg_egg;
  extern complex <double> *qpg_egg;
  extern complex <double> *qbpg_egg;
  extern complex <double> *qqb_egg;
  extern complex <double> *qq_egg;
  extern complex <double> *qqp_egg;
  extern complex <double> *qqbp_egg;
  extern complex <double> *qbq_egg;
  extern complex <double> *qbqp_egg;
  extern complex <double> *qbqbp_egg;
  extern complex <double> *qpqp_egg;
  extern complex <double> *qpqbp_egg;
  extern complex <double> *qbpqp_egg;
  extern complex <double> *qq_eqbg;
  extern complex <double> *gg_eqbg;
  extern complex <double> *qbg_eqbg;
  extern complex <double> *qbq_eqbg;
  extern complex <double> *qbqp_eqbg;
  extern complex <double> *qbqbp_eqbg;
  extern complex <double> *qqbp_eqpg;
  extern complex <double> *gg_eqpg;
  extern complex <double> *qpg_eqpg;
  extern complex <double> *qbqbp_eqpg;
  extern complex <double> *qpqp_eqpg;
  extern complex <double> *qpqbp_eqpg;
  extern complex <double> *qqp_eqbpg;
  extern complex <double> *gg_eqbpg;
  extern complex <double> *qbpg_eqbpg;
  extern complex <double> *qbqp_eqbpg;
  extern complex <double> *qpqp_eqbpg;
  extern complex <double> *qbpqp_eqbpg;
#pragma omp threadprivate(qqb_eqqb,qg_eqqb,qq_eqqb,qqp_eqqb,qqbp_eqqb,gg_eqqb,qbg_eqqb,qpg_eqqb,qbpg_eqqb,qbq_eqqb,qpqbp_eqqb,qbpqp_eqqb,qbqp_eqqb,qbqbp_eqqb,qpqp_eqqb,qqb_eqg,qg_eqg,qq_eqg,qqp_eqg,qqbp_eqg,gg_eqg,qbg_eqg,qpg_eqg,qbpg_eqg,qbq_eqg,qbqp_eqg,qbqbp_eqg,qpqp_eqg,qpqbp_eqg,qbpqp_eqg,qg_eqq,qq_eqq,qbg_eqq,qg_eqqp,qqp_eqqp,qbpg_eqqp,qg_eqqbp,qqbp_eqqbp,qpg_eqqbp,qg_egg,gg_egg,qbg_egg,qpg_egg,qbpg_egg)
#pragma omp threadprivate(gg_eqq,qbq_eqq,qbqp_eqq,qbqbp_eqq,gg_eqqp,qbqp_eqqp,qpqp_eqqp,qbpqp_eqqp,gg_eqqbp,qbqbp_eqqbp,qpqp_eqqbp,qpqbp_eqqbp,qqb_egg,qq_egg,qqp_egg,qqbp_egg,qbq_egg,qbqp_egg,qbqbp_egg,qpqp_egg,qpqbp_egg,qbpqp_egg,qq_eqbg,gg_eqbg,qbg_eqbg,qbq_eqbg,qbqp_eqbg,qbqbp_eqbg,qqbp_eqpg,gg_eqpg,qpg_eqpg,qbqbp_eqpg,qpqp_eqpg,qpqbp_eqpg,qqp_eqbpg,gg_eqbpg,qbpg_eqbpg,qbqp_eqbpg,qpqp_eqbpg,qbpqp_eqbpg)

  extern complex <double> *qg_1_eqqb;
  extern complex <double> *qg_2_eqqb;
  extern complex <double> *qq_1_eqqb;
  extern complex <double> *qq_2_eqqb;
  extern complex <double> *qqp_1_eqqb;
  extern complex <double> *qqp_2_eqqb;
  extern complex <double> *qqbp_1_eqqb;
  extern complex <double> *qqbp_2_eqqb;
  extern complex <double> *qbg_1_eqqb;
  extern complex <double> *qbg_2_eqqb;
  extern complex <double> *qpg_1_eqqb;
  extern complex <double> *qpg_2_eqqb;
  extern complex <double> *qbpg_1_eqqb;
  extern complex <double> *qbpg_2_eqqb;
  extern complex <double> *qqb_eqg_1;
  extern complex <double> *qg_1_eqg_1;
  extern complex <double> *qg_2_eqg_1;
  extern complex <double> *qq_1_eqg_1;
  extern complex <double> *qqp_1_eqg_1;
  extern complex <double> *qqbp_1_eqg_1;
  extern complex <double> *gg_eqg_1;
  extern complex <double> *qbg_1_eqg_1;
  extern complex <double> *qbg_2_eqg_1;
  extern complex <double> *qpg_1_eqg_1;
  extern complex <double> *qpg_2_eqg_1;
  extern complex <double> *qbpg_1_eqg_1;
  extern complex <double> *qbpg_2_eqg_1;
  extern complex <double> *qqb_eqg_2;
  extern complex <double> *qg_1_eqg_2;
  extern complex <double> *qg_2_eqg_2;
  extern complex <double> *qq_2_eqg_2;
  extern complex <double> *qqp_2_eqg_2;
  extern complex <double> *qqbp_2_eqg_2;
  extern complex <double> *gg_eqg_2;
  extern complex <double> *qbg_1_eqg_2;
  extern complex <double> *qbg_2_eqg_2;
  extern complex <double> *qpg_1_eqg_2;
  extern complex <double> *qpg_2_eqg_2;
  extern complex <double> *qbpg_1_eqg_2;
  extern complex <double> *qbpg_2_eqg_2;
  extern complex <double> *qg_1_eqq_1;
  extern complex <double> *qq_1_eqq_1;
  extern complex <double> *qbg_2_eqq_1;
  extern complex <double> *qg_2_eqq_2;
  extern complex <double> *qq_2_eqq_2;
  extern complex <double> *qbg_1_eqq_2;
  extern complex <double> *qg_1_eqqp_1;
  extern complex <double> *qqp_1_eqqp_1;
  extern complex <double> *qbpg_2_eqqp_1;
  extern complex <double> *qg_2_eqqp_2;
  extern complex <double> *qqp_2_eqqp_2;
  extern complex <double> *qbpg_1_eqqp_2;
  extern complex <double> *qg_1_eqqbp_1;
  extern complex <double> *qqbp_1_eqqbp_1;
  extern complex <double> *qpg_2_eqqbp_1;
  extern complex <double> *qg_2_eqqbp_2;
  extern complex <double> *qqbp_2_eqqbp_2;
  extern complex <double> *qpg_1_eqqbp_2;
  extern complex <double> *qg_1_egg;
  extern complex <double> *qg_2_egg;
  extern complex <double> *qbg_1_egg;
  extern complex <double> *qbg_2_egg;
  extern complex <double> *qpg_1_egg;
  extern complex <double> *qpg_2_egg;
  extern complex <double> *qbpg_1_egg;
  extern complex <double> *qbpg_2_egg;
#pragma omp threadprivate(qg_1_eqqb,qg_2_eqqb,qq_1_eqqb,qq_2_eqqb,qqp_1_eqqb,qqp_2_eqqb,qqbp_1_eqqb,qqbp_2_eqqb,qbg_1_eqqb,qbg_2_eqqb,qpg_1_eqqb,qpg_2_eqqb,qbpg_1_eqqb,qbpg_2_eqqb,qqb_eqg_1,qg_1_eqg_1,qg_2_eqg_1,qq_1_eqg_1,qqp_1_eqg_1,qqbp_1_eqg_1,gg_eqg_1,qbg_1_eqg_1,qbg_2_eqg_1,qpg_1_eqg_1,qpg_2_eqg_1,qbpg_1_eqg_1,qbpg_2_eqg_1,qqb_eqg_2,qg_1_eqg_2,qg_2_eqg_2,qq_2_eqg_2,qqp_2_eqg_2,qqbp_2_eqg_2,gg_eqg_2,qbg_1_eqg_2,qbg_2_eqg_2,qpg_1_eqg_2,qpg_2_eqg_2,qbpg_1_eqg_2,qbpg_2_eqg_2,qg_1_eqq_1,qq_1_eqq_1,qbg_2_eqq_1,qg_2_eqq_2,qq_2_eqq_2,qbg_1_eqq_2,qg_1_eqqp_1,qqp_1_eqqp_1,qbpg_2_eqqp_1,qg_2_eqqp_2,qqp_2_eqqp_2,qbpg_1_eqqp_2,qg_1_eqqbp_1,qqbp_1_eqqbp_1,qpg_2_eqqbp_1,qg_2_eqqbp_2,qqbp_2_eqqbp_2,qpg_1_eqqbp_2,qg_1_egg,qg_2_egg,qbg_1_egg,qbg_2_egg,qpg_1_egg,qpg_2_egg,qbpg_1_egg,qbpg_2_egg)
  
  void allocate();
  void reset();
  void calc(complex <double> b = 0.);
  void calc1d(complex <double> b = 0.);
  void calc2d(complex <double> b = 0.);
  void ccalc();
  void ccalc1d();
  void ccalc2d();
  void ccalcb(complex <double> b = 0.);
  void free();

  extern complex <double> h4st_qqb_qqb   (int idx);
  extern complex <double> h4st_qg_qqb    (int idx);
  extern complex <double> h4st_qq_qqb    (int idx);
  extern complex <double> h4st_qqp_qqb   (int idx);
  extern complex <double> h4st_qqbp_qqb  (int idx);
  extern complex <double> h4st_gg_qqb    (int idx);
  extern complex <double> h4st_qbg_qqb   (int idx);
  extern complex <double> h4st_qpg_qqb   (int idx);
  extern complex <double> h4st_qbpg_qqb  (int idx);
  extern complex <double> h4st_qbq_qqb   (int idx);
  extern complex <double> h4st_qbqp_qqb  (int idx);
  extern complex <double> h4st_qbqbp_qqb (int idx);
  extern complex <double> h4st_qpqp_qqb  (int idx);
  extern complex <double> h4st_qpqbp_qqb (int idx);
  extern complex <double> h4st_qbpqp_qqb (int idx);

  extern complex <double> h4st_qqb_qg   (int idx);
  extern complex <double> h4st_qg_qg    (int idx);
  extern complex <double> h4st_qq_qg    (int idx);
  extern complex <double> h4st_qqp_qg   (int idx);
  extern complex <double> h4st_qqbp_qg  (int idx);
  extern complex <double> h4st_gg_qg    (int idx);
  extern complex <double> h4st_qbg_qg   (int idx);
  extern complex <double> h4st_qpg_qg   (int idx);
  extern complex <double> h4st_qbpg_qg  (int idx);
  extern complex <double> h4st_qbq_qg   (int idx);
  extern complex <double> h4st_qbqp_qg  (int idx);
  extern complex <double> h4st_qbqbp_qg (int idx);
  extern complex <double> h4st_qpqp_qg  (int idx);
  extern complex <double> h4st_qpqbp_qg (int idx);
  extern complex <double> h4st_qbpqp_qg (int idx);

  extern complex <double> h4st_qqb   (int idx);
  extern complex <double> h4st_qg    (int idx);
  extern complex <double> h4st_qq    (int idx);
  extern complex <double> h4st_qqp   (int idx);
  extern complex <double> h4st_qqbp  (int idx);
  extern complex <double> h4st_gg    (int idx);
  extern complex <double> h4st_qbg   (int idx);
  extern complex <double> h4st_qpg   (int idx);
  extern complex <double> h4st_qbpg  (int idx);
  extern complex <double> h4st_qbq   (int idx);
  extern complex <double> h4st_qbqp  (int idx);
  extern complex <double> h4st_qbqbp (int idx);
  extern complex <double> h4st_qpqp  (int idx);
  extern complex <double> h4st_qpqbp (int idx);
  extern complex <double> h4st_qbpqp (int idx);
  
}

#endif
